package spotai;

public class Node {  
  public int[][] playfield;      // empty: -1, players: 0, 1, 2, 3
  public float[] utilities;      // playfield eval for each player, sums to zero 
  public Coordinate source;      // move from or Coordinate.PASS for no move
  public Coordinate destination; // move to, source maybe null for single clicks
  public NodeType nodeType;      // intermediate, draw, win
  public int winner;             // if nodeType == win, who won?
  public int player;             // the player that generates the child nodes
  public int bonus;              // moved in response to the bonus game?
  
  public void set(final Node node) {
    setPlayfield(node.playfield);
    setUtilities(node.utilities);
    source = node.source;
    destination = node.destination;
    nodeType = node.nodeType;
    winner = node.winner;
    player = node.player;
    bonus = node.bonus;
  }
  
  public void setUtilities(final float[] utilities) {
    System.arraycopy(utilities, 0, this.utilities, 0, utilities.length);
  }
  
  public void setPlayfield(final int[][] playfield) {
    for(int i = playfield.length - 1; i >= 0; i--) {
      System.arraycopy(playfield[i], 0, this.playfield[i], 0, 
          playfield[i].length);
    }
  }
  
  public void printPlayfield() {
    System.out.println();
    System.out.println("  0 1 2 3 4 5 6");
    final StringBuilder sb = new StringBuilder();
    for(int y = 0; y < playfield.length; y++) {
      sb.setLength(0);
      sb.append(y);
      for(int x = 0; x < playfield[y].length; x++) {
        sb.append(' ');
        if (playfield[y][x] < 0) {
          sb.append('.');
        } else {
          sb.append((char)('A' + playfield[y][x]));
        }
      }
      System.out.println(sb);
    }    
    System.out.println();
  }
}